Ext.define('DSS.component.ActionConfigurator',
{
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	height : '100%',
	layout : 'border',
	selectedElement : null,
	gridStore : null,
	grids : {},
	mainGrid : null,
	macPanel : null,
	lblSelectorAnzeige : null,
	iDefaultWidth : 150,
	iDefaultHeight : 293,
	oButtonNew:null,
	oButtonEdit:null,
	oButtonUp:null,
	oButtonDown:null,
	oButtonDelete:null,
	setHeight:function (oHeight)
	{
		this.macPanel.setHeight(oHeight-30);
		this.iDefaultHeight=oHeight-57;
		for (var oKey in this.grids)
			this.grids[oKey].setHeight(this.iDefaultHeight);
		this.callParent(arguments);
	},
	defMacGridRenderer : function(val, metadata, record,
			colIdx, store, view) {
		if (record.get('name') == '-')
			return '<hr>';
		else if ((record.get('next') == true)
				|| (record.get('group') != null)
				|| (record.get('dSID') != null)) {
			if (record.get('icon') == null)
				return '<table><tr><td colspan="2"  width="100%">'
						+ record.get('name')
						+ '</td><td>&gt;</td></tr></table>';
			else
				return '<table><tr><td><img src="'
						+ record.get('icon')
						+ '" style="margin-right: 5px;"></td><td width="100%">'
						+ record.get('name')
						+ '</td><td>&gt;</td></tr></table>';
		} else {
			if (record.get('checkable') !=null)
				if (record.get('checkable')) {
					if (record.get('checked')==true)
						return '<table><tr><td><div style="width:13px;height:13px;background-image:url(images/dss/checkbox.gif); background-position: 0px -13px;" /></td>'
						    + '<td style="padding-left: 5px;" colspan="2" width="100%">'
							+ record.get('name')
							+ '</td></tr></table>';
					else
						return '<table><tr><td><div style="width:13px;height:13px;background-image:url(images/dss/checkbox.gif);" /></td>'
					    + '<td style="padding-left: 5px;" colspan="2" width="100%">'
						+ record.get('name')
						+ '</td></tr></table>';
				}
			if (record.get('icon') == null)
				return '<table><tr><td colspan="3" width="100%">'
						+ record.get('name')
						+ '</td></tr></table>';
			else
				return '<table><tr><td><img src="'
						+ record.get('icon')
						+ '" style="margin-right: 5px;"></td><td colspan="2" width="100%">'
						+ record.get('name')
						+ '</td></tr></table>';
		}

	},
	defMainGridRenderer : function(val, metadata, record,
			colIdx, store, view) {
		var oAction = record.get('action');
		switch (oAction.type) {
		case 'zone-scene': { // scene, group,zone,force
			var sString = '<table><tr><td style="padding-right:5px;">'+ dss.staticDataModel.getImageForScene(
							oAction.params.zone,
							oAction.params.group,
							oAction.params.scene) + "</td>";

			sString += "<td>"
					+ dss.staticDataModel.getNameForScene(
							oAction.params.zone,
							oAction.params.group,
							oAction.params.scene);
			if (oAction.params.group!=0)
				sString +=" f&uuml;r " + dss.staticDataModel.getNameForGroup(oAction.params.zone, oAction.params.group);
			if (oAction.params.zone!=0)
				sString+= " in " + dss.staticDataModel.getNameForZone(oAction.params.zone);
			if (oAction.params.force)
				sString += ' !';
			sString += "</td></tr></table>";
			return sString;
			break;
		}
		case 'device-scene': {// scene, dsid,force
			var oDevice = dss.staticDataModel
					.getDevice(oAction.params.dsid);
		
			var sString = oDevice.name + " in ";
			sString += dss.staticDataModel
					.getNameForZone(oDevice.ZoneID);
			if (oAction.params.force)
				sString += ' !';

			if (oAction.params.scene==13) {// aus
				sString='<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice)+ '"></td><td>' 
					+ sString + " ausschalten</td></tr></table>"; 
			} else if (oAction.params.scene==14) {// ein
				sString='<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice)+ '"></td><td>' 
				+ sString + " einschalten</td></tr></table>"; 
		    } else if (oAction.params.scene==51) { // ein loc
				sString='<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice)+  '"></td><td>' 
				+ sString + " einschalten mit Lokalpriorit&auml;t</td></tr></table>"; 
			} else {
				sString='<table><tr><td style="padding-right:5px;">'
					+ dss.staticDataModel.getImageForScene(oDevice.ZoneID, oDevice.GroupID,oAction.params.scene) + "</td><td>"
					+ dss.staticDataModel.getNameForScene(oDevice.ZoneID, oDevice.GroupID,oAction.params.scene)
					+ " f&uuml;r "+ sString + "</td></tr></table>"	
			}			
			return sString;
			break;
		}
		case 'device-value': { // value, dsid
			var oDevice = dss.staticDataModel
					.getDevice(oAction.params.dsid);
			var sString = "<table><tr><td>"
					+ Math.round(oAction.params.value / 2.55)
					+ "% f&uuml;r ";
			sString += oDevice.name + " in ";
			sString += dss.staticDataModel
					.getNameForZone(oDevice.ZoneID);
			sString += "</td></tr></table>";
			return sString;
			break;
		}
		case 'device-blink': {// dsid
			var oDevice = dss.staticDataModel
					.getDevice(oAction.params.dsid);
			var sString = '<table><tr><td style="padding-right:5px;"><img src="'+
			dss.staticDataModel.getImageForDevice(oDevice)+ '"></td>';
			sString +="<td>" + oDevice.name
					+ " in ";
			sString += dss.staticDataModel
					.getNameForZone(oDevice.ZoneID);
			sString += " blinkt</td></tr></table>";
			return sString;
			break;
		}
		case 'zone-blink': {// group,zone
			var sString = '<table><tr><td style="padding-right:5px;"><img src="images/sceneIcons/scene_blink.png"></td>';
			sString +="<td>" +  dss.staticDataModel.getNameForGroup(
					oAction.params.zone, oAction.params.group)
					+ " in ";
			sString += dss.staticDataModel
					.getNameForZone(oAction.params.zone);
			sString += " blinkt</td></tr></table>";
			return sString;
			break;
		}
		case 'custom-event': { // event
			return "Highlevel Event: " + oAction.params.event
			break;
		}
		case 'url': { // url
			return "URL: " + oAction.params.url
			break;
		}
		}
	},
	initStores : function() {

		if (Ext.data.StoreManager
				.lookup('actionConfigurator_l1Store') == null) {
			var Aktionen = [
					{
						name : 'Aktivit&auml;t in Raum',
						id : 0,
						next : true,
						icon : null
					},
					{
						name : 'einzelnes Ger&auml;t',
						id : 1,
						next : true,
						icon : null
					},
					{
						name : 'Highlevel Event',
						id : 2,
						next : true,
						icon : null
					},
					{
						name : 'URL aufrufen',
						id : 3,
						next : true,
						icon : null
					},
					{
						name : '-',
						id : -1,
						next : false,
						icon : null
					},
					{
						name : 'Panik',
						id : 4,
						next : false,
						icon : dss.staticDataModel
								.getImagePathForScene(0, 0, 65)
					},
					{
						name : 'Klingeln',
						id : 5,
						next : false,
						icon : dss.staticDataModel
								.getImagePathForScene(0, 0, 73)
					},
					{
						name : 'Gehen',
						id : 6,
						next : false,
						icon : dss.staticDataModel
								.getImagePathForScene(0, 0, 72)
					},
					{
						name : 'Kommen',
						id : 7,
						next : false,
						icon : dss.staticDataModel
								.getImagePathForScene(0, 0, 71)
					} ];
			Ext.create('Ext.data.Store', {
				storeId : 'actionConfigurator_l1Store',
				fields : [ 'id', 'name', 'next', 'icon' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			Ext.data.StoreManager.lookup(
					'actionConfigurator_l1Store').add(Aktionen);
		}
		if (Ext.data.StoreManager
				.lookup('actionConfigurator_zoneStore') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'actionConfigurator_zoneStore',
				fields : [ 'ZoneID', 'name' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			Ext.data.StoreManager.lookup(
					'actionConfigurator_zoneStore').add(
					dss.staticDataModel.getZoneArray());
		}

		this.gridStore = Ext.create('Ext.data.Store', {

			fields : [ 'pos', 'action' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
	},
	getGroupStore : function(ZoneID) {
		if (Ext.data.StoreManager
				.lookup('actionConfigurator_groupStore_'
						+ ZoneID) == null) {
			Ext
					.create(
							'Ext.data.Store',
							{
								storeId : 'actionConfigurator_groupStore_'
										+ ZoneID,
								fields : [ 'group', 'name',
										'icon', 'reachable' ],
								proxy : {
									type : 'memory',
									reader : {
										type : 'json',
										root : 'items'
									}
								}
							});
			var oGroup = dss.staticDataModel
					.getGroupForZone(ZoneID);
			Ext.data.StoreManager.lookup(
					'actionConfigurator_groupStore_' + ZoneID)
					.add(oGroup);
		}
		return Ext.data.StoreManager
				.lookup('actionConfigurator_groupStore_'
						+ ZoneID);
	},
	getSceneStore : function(ZoneID, groupID) {
		if (Ext.data.StoreManager
				.lookup('actionConfigurator_szeneStore_'
						+ ZoneID + '_' + groupID) == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'actionConfigurator_szeneStore_'
						+ ZoneID + '_' + groupID,
				fields : [ 'id', 'name', 'reachable', 'icon',
						'outputMode' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			var oScenes = dss.staticDataModel.getScenes(ZoneID,groupID);
			for (var iIndex=0;iIndex<oScenes.length;iIndex++) 
			{
				var oObject={};
				oObject.id=oScenes[iIndex].id;
				oObject.reachable=oScenes[iIndex].reachable;
				oObject.icon=oScenes[iIndex].icon;
				if (oScenes[iIndex].name==oScenes[iIndex].defaultName)
					oObject.name=oScenes[iIndex].name;
				else
					oObject.name=oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
				Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
			}
			
		}
		return Ext.data.StoreManager
				.lookup('actionConfigurator_szeneStore_'
						+ ZoneID + '_' + groupID);

	},
	getDeviceStore : function(ZoneID) {
		if (Ext.data.StoreManager
				.lookup('actionConfigurator_deviceStore_'
						+ ZoneID) == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'actionConfigurator_deviceStore_'
						+ ZoneID,
				fields : [ 'dSID', 'name', 'icon', 'present' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			var oDevice = dss.staticDataModel
					.getDevicesForZone(ZoneID, 0);
			Ext.data.StoreManager.lookup(
					'actionConfigurator_deviceStore_' + ZoneID)
					.add(oDevice);
		}
		return Ext.data.StoreManager
				.lookup('actionConfigurator_deviceStore_'
						+ ZoneID);
	},
	constructGridLvlDeviceScene : function(zoneID, groupID,fAll,fForce) {
		var oSceneControlStore = Ext.create('Ext.data.Store', {
			fields : [ 'id', 'name', 'icon', 'reachable' , 'checkable' , 'checked'],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		if (fAll==null)
			fAll=false;
		if (fForce==null)
			fForce=false

		var oSceneStore = this.getSceneStore(zoneID, groupID);
		oSceneControlStore.add({
			id : -3,
			name : 'alle Stimmungen anzeigen',
			icon : null,
			reachable : true,
			checkable:true,
			checked:fAll
		});
		oSceneControlStore.add({
			id : -2,
			name : 'Lokalpriorit&auml;t ignorieren',
			icon : null,
			reachable : true,
			checkable:true,
			checked:fForce
		});
		oSceneControlStore.add({
			id : -1,
			name : '-',
			icon : null,
			reachable : true
		});
		oSceneStore.each(function(record) {
			var oNewRecord = record.copy()
			if (oNewRecord.get('reachable')||fAll)
				oSceneControlStore.add(oNewRecord);
		});

		this.grids.lvlDeviceScene = Ext.create(
				'Ext.grid.Panel', {
					height : this.iDefaultHeight,
					width : 174,
					autoScroll : true,
					viewConfig : {
						stripeRows : true
					},
					store : oSceneControlStore,
					columns : [ {
						sortable : false,
						hideable : false,
						text : 'Stimmung',
						dataIndex : 'name',
						flex : 1,
						renderer : this.defMacGridRenderer
					} ]
				});
		this.grids.lvlDeviceScene.parent = this;
		this.macPanel.add(this.grids.lvlDeviceScene);
		
		this.grids.lvlDeviceScene.on('itemclick',function(grid, record) {
			if (record.get('checkable')!=null)
				if (record.get('checkable')) {
					var fChecked=!record.get('checked');
					record.set('checked',fChecked);
					grid.getSelectionModel().deselectAll();
					if (record.get('id') ==-3) {
						// alle Stimmungen
						grid.store.removeAll();

						grid.store.add({
							id : -3,
							name : 'alle Stimmungen anzeigen',
							icon : null,
							reachable : true,
							checkable:true,
							checked:record.get('checked')

						});
						grid.store.add({
							id : -2,
							name : 'Lokalpriorit&auml;t ignorieren',
							icon : null,
							reachable : true,
							checkable:true,
							checked:false

						});
						grid.store.add({
							id : -1,
							name : '-',
							icon : null,
							reachable : true
						});
						oSceneStore.each(function(record) {
							var oNewRecord = record.copy();
							if (oNewRecord.get('reachable') || fChecked)
								grid.store.add(oNewRecord);
						});
					
					}
					if (record.get('id') ==-2) {
						// lokal prio
					}
				}
			
		});
		this.grids.lvlDeviceScene.on('itemdblclick',function(grid, record) {
			if (record.get('id') < 0)
				return;
			if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 1) {
				var dSID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');	
				var oSelectedRecord=grid.store.findRecord('id',-2);
				if (dSID!=null) {
					var oObject = {
						type : 'device-scene',
						params : {
							dsid : dSID,
							scene : record.get('id'),
							force : oSelectedRecord.get('checked')
						}
					};
					this.parent.setSelectedSubItem(oObject);
				}
			}
		});
		
	},
	constructGridLvlDeviceActions : function(dSID) {
		var oDeviceActionControlStore = Ext.create(
				'Ext.data.Store', {
					fields : [ 'id', 'name', 'icon', 'next' ],
					proxy : {
						type : 'memory',
						reader : {
							type : 'json',
							root : 'items'
						}
					}
				});
		var oDeviceObject = dss.staticDataModel.getDevice(dSID);
		if (oDeviceObject.GroupID == 1) {
			oDeviceActionControlStore.add({
				id : 5,
				name : 'Stimmung aufrufen',
				icon : null,
				next : true
			});
			oDeviceActionControlStore.add({
				id : 1,
				name : 'Ausschalten',
				icon : dss.staticDataModel.getImagePathForScene(0,1,0),
				next : false
			});
			oDeviceActionControlStore.add({
				id : 2,
				name : 'Einschalten',
				icon : dss.staticDataModel.getImagePathForScene(0,1,5),
				next : false
			});
			oDeviceActionControlStore.add({
				id : 3,
				name : 'Einschalten mit Lokalpriorit&auml;t',
				icon : dss.staticDataModel.getImagePathForScene(0,1,5),
				next : false
			});
			oDeviceActionControlStore.add({
				id : 4,
				name : 'Blinken',
				icon : 'images/sceneIcons/scene_blink.png',
				next : false
			});
		} else if (oDeviceObject.GroupID == 8) {
			oDeviceActionControlStore.add({
				id : 1,
				name : 'Ausschalten',
				icon : dss.staticDataModel.getImagePathForScene(0,oDeviceObject.GroupID,0),
				next : false
			});
			oDeviceActionControlStore.add({
				id : 2,
				name : 'Einschalten',
				icon : dss.staticDataModel.getImagePathForScene(0,oDeviceObject.GroupID,5),
				next : false
			});
		} else {
			oDeviceActionControlStore.add({
				id : 5,
				name : 'Stimmung aufrufen',
				icon : null,
				next : true
			});
			oDeviceActionControlStore.add({
				id : 4,
				name : 'Blinken',
				icon : 'images/sceneIcons/scene_blink.png',
				next : false
			});
		}

		this.grids.lvlDeviceAction = Ext.create(
				'Ext.grid.Panel', {
					height : this.iDefaultHeight,
					width : this.iDefaultWidth,
					autoScroll : true,
					viewConfig : {
						stripeRows : true
					},
					store : oDeviceActionControlStore,
					columns : [ {
						sortable : false,
						hideable : false,
						text : 'Aktivit&auml;t',
						dataIndex : 'name',
						flex : 1,
						renderer : this.defMacGridRenderer
					} ]
				});
		this.grids.lvlDeviceAction.parent = this;

		this.grids.lvlDeviceAction.on('itemclick', function(
				grid, record) {
			this.parent.macPanel
					.remove(this.parent.grids.lvlDeviceScene);
			var id = record.get('id');
			if (id == 5) {
				var dSID = this.parent.grids.lvlDevice
						.getSelectionModel().getSelection()[0]
						.get('dSID');
				var oDeviceObject = dss.staticDataModel
						.getDevice(dSID);
				this.parent.constructGridLvlDeviceScene(
						oDeviceObject.ZoneID,
						oDeviceObject.GroupID);
			}
		});

		this.grids.lvlDeviceAction.on('itemdblclick',function(grid, record) {
			if (record.get('next'))
				return;
			if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 1) {
				var dSID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');			
				if (dSID!=null) {
					if (record.get('id')==1)  //aus
					{
						var oObject = {
								type : 'device-scene',
								params : {
									dsid : dSID,
									scene : 13,
									force : false
								}
							};
						this.parent.setSelectedSubItem(oObject);
					}
					if (record.get('id')==2) // ein
					{
						var oObject = {
								type : 'device-scene',
								params : {
									dsid : dSID,
									scene : 14,
									force : false
								}
							};
						this.parent.setSelectedSubItem(oObject);
					}
					if (record.get('id')==3) // ein mit prio
					{
						var oObject = {
								type : 'device-scene',
								params : {
									dsid : dSID,
									scene : 51,
									force : false
								}
							};
						this.parent.setSelectedSubItem(oObject);
					}
					if (record.get('id')==4) //blinken
					{
						var oObject = {
								type : 'device-blink',
								params : {
									dsid : dSID,
								}
							};
						this.parent.setSelectedSubItem(oObject);
					}

				}
			}
		});
		
		
		this.macPanel.add(this.grids.lvlDeviceAction);

	},
	constructGridLvlDevice : function(zoneID) {
		var oDeviceControlStore = Ext.create('Ext.data.Store',
				{
					fields : [ 'dSID', 'name', 'icon',
							'present' ],
					proxy : {
						type : 'memory',
						reader : {
							type : 'json',
							root : 'items'
						}
					}
				});

		var oDeviceStore = this.getDeviceStore(zoneID);
		oDeviceStore.each(function(record) {
			var oNewRecord = record.copy()
			if (oNewRecord.get('present'))
				if (oNewRecord.get('outputMode') != 0)
					oDeviceControlStore.add(oNewRecord);
		});
		this.grids.lvlDevice = Ext.create('Ext.grid.Panel', {
			height : this.iDefaultHeight,
			width : this.iDefaultWidth,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			store : oDeviceControlStore,
			columns : [ {
				sortable : false,
				hideable : false,
				text : 'Ger&auml;t',
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});
		this.grids.lvlDevice.parent = this;
		this.grids.lvlDevice.on('itemclick', function(grid,
				record) {
			this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
			this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
			var dSID = record.get('dSID');
			this.parent.constructGridLvlDeviceActions(dSID);
		});
		this.macPanel.add(this.grids.lvlDevice);
	},
	constructGridLvlGroupScene : function(zoneID, groupID,fAll,fForce) {
		var oSceneControlStore = Ext.create('Ext.data.Store', {
			fields : [ 'id', 'name', 'icon', 'reachable','checkable','checked' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		if (fAll==null)
			fAll=false;
		if (fForce==null)
			fForce=false
		var oSceneStore = this.getSceneStore(zoneID, groupID);
		oSceneControlStore.add({
			id : -3,
			name : 'alle Stimmungen anzeigen',
			icon : null,
			reachable : true,
			checkable:true,
			checked:fAll

		});
		oSceneControlStore.add({
			id : -2,
			name : 'Lokalpriorit&auml;t ignorieren',
			icon : null,
			reachable : true,
			checkable:true,
			checked:fForce

		});
		oSceneControlStore.add({
			id : -1,
			name : '-',
			icon : null,
			reachable : true
		});
		oSceneStore.each(function(record) {
			var oNewRecord = record.copy()
			if (oNewRecord.get('reachable')||fAll)
				if (oNewRecord.get('id')<64)
					oSceneControlStore.add(oNewRecord);
		});

		this.grids.lvlScene = Ext.create('Ext.grid.Panel', {
			height : this.iDefaultHeight,
			width : 324,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			store : oSceneControlStore,
			columns : [ {
				sortable : false,
				hideable : false,
				text : 'Stimmung',
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});
		this.grids.lvlScene.parent = this;
		this.grids.lvlScene.on('itemclick',function(grid, record) {
			if (record.get('checkable')!=null)
				if (record.get('checkable')) {
					var fChecked=!record.get('checked');
					record.set('checked',fChecked);
					grid.getSelectionModel().deselectAll();
					if (record.get('id') ==-3) {
						// alle Stimmungen
						grid.store.removeAll();

						grid.store.add({
							id : -3,
							name : 'alle Stimmungen anzeigen',
							icon : null,
							reachable : true,
							checkable:true,
							checked:record.get('checked')

						});
						grid.store.add({
							id : -2,
							name : 'Lokalpriorit&auml;t ignorieren',
							icon : null,
							reachable : true,
							checkable:true,
							checked:false

						});
						grid.store.add({
							id : -1,
							name : '-',
							icon : null,
							reachable : true
						});
						oSceneStore.each(function(record) {
							var oNewRecord = record.copy();
							if (oNewRecord.get('reachable') || fChecked)
								grid.store.add(oNewRecord);
						});
					
					}
					if (record.get('id') ==-2) {
						// lokal prio
					}
				}
			
		});
		this.grids.lvlScene.on('itemdblclick',function(grid, record) {
			if (record.get('id') < 0)
				return;
			if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
				var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');			
				var groupID = this.parent.grids.lvlGroup.getSelectionModel().getSelection()[0].get('group');
				if (zoneID!=null)
					if (groupID!=null) {
						var oSelectedRecord=grid.store.findRecord('id',-2);
						var oObject = {
							type : 'zone-scene',
							params : {
								zone : zoneID,
								group : groupID,
								scene : record.get('id'),
								force : oSelectedRecord.get('checked')
							}
						};
						this.parent.setSelectedSubItem(oObject);
					}
			}
		});

		
		this.macPanel.add(this.grids.lvlScene);

	},
	constructGridLvlRoom : function() {
		var oZoneControlStore = Ext.create('Ext.data.Store', {
			fields : [ 'ZoneID', 'name' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});

		var oZoneStore = Ext.data.StoreManager
				.lookup('actionConfigurator_zoneStore');
		oZoneStore.each(function(record) {
			var oNewRecord = record.copy()
			if (oNewRecord.get('ZoneID') != 0)
				oZoneControlStore.add(oNewRecord);
		});

		this.grids.lvlRoom = Ext
				.create(
						'Ext.grid.Panel',
						{
							height : this.iDefaultHeight,
							width : this.iDefaultWidth,
							autoScroll : true,
							viewConfig : {
								stripeRows : true
							},
							store : oZoneControlStore,
							columns : [ {
								sortable : false,
								hideable : false,
								text : 'Raum',
								dataIndex : 'name',
								flex : 1,
								renderer : function(val,
										metadata, record,
										colIdx, store, view) {
									return '<table><tr><td width="100%">'
											+ record
													.get('name')
											+ '</td><td>&gt;</td></tr></table>';
								}
							} ]
						});

		this.grids.lvlRoom.parent = this;
		this.grids.lvlRoom.on('itemclick', function(grid,
				record) {
			this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
			this.parent.macPanel.remove(this.parent.grids.lvlGroup);
			this.parent.macPanel.remove(this.parent.grids.lvlScene);
			this.parent.macPanel.remove(this.parent.grids.lvlDevice);
			this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
			if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
				var zoneID = record.get('ZoneID');
				this.parent.constructGridLvlGroup(zoneID);
			} else if (this.parent.grids.lvl1
					.getSelectionModel().getSelection()[0]
					.get('id') == 1) {
				var zoneID = record.get('ZoneID');
				this.parent.constructGridLvlDevice(zoneID);
			}
		});
		this.macPanel.add(this.grids.lvlRoom);
	},
	constructGridLvlHigh : function() {
		
		
		var oStore=Ext.create('Ext.data.Store',{
			fields : [ 'name' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});
		oStore.add(dss.staticDataModel.HLECache);
		
		
		this.grids.lvlHighLevelEvent = Ext.create(
			'Ext.grid.Panel',
			{
				height : this.iDefaultHeight,
				width : 624,
				autoScroll : true,
				viewConfig : {
					stripeRows : true
				},
				store : oStore,
				columns : [ {
					sortable : false,
					hideable : false,
					text : 'Highlevel Event',
					dataIndex : 'name',
					flex : 1,
					renderer : function(val,
							metadata, record,
							colIdx, store, view) {
						return '<table><tr><td width="100%">'
								+ record.get('name')
								+ '</td></tr></table>';
					}
				} ]
			});
		this.grids.lvlHighLevelEvent.parent = this;
		this.macPanel.add(this.grids.lvlHighLevelEvent);
		
		this.grids.lvlHighLevelEvent.on('itemdblclick',function(grid, record) {
			var oObject = {
				type : 'custom-event',
				params : {
					event : record.get('name'),
				}
			};
			this.parent.setSelectedSubItem(oObject);
		});
		
	},
	constructGridLvlURL : function() {
		this.grids.lvlURLButton = Ext.create ('Ext.button.Button',{
			text:'&Uuml;bernehmen',
			margin: 5, 
			handler: function ()
			{
				if (this.parent.grids.lvlURLText.isValid()) {
					var oObject = {
							type : 'url',
							params : {
								url : this.parent.grids.lvlURLText.getValue(),
							}
						};
					this.parent.setSelectedSubItem(oObject);
				}
			}
		});
		
		this.grids.lvlURLText = Ext.create('Ext.form.field.Text',{
			xtype : 'textfield',
			name : 'url',
			margin : 5,
			fieldLabel : 'URL',
			allowBlank : false,
			labelWidth : 30,
			width : 614
		});
		this.grids.lvlURL = Ext.create('Ext.panel.Panel', {
			height : this.iDefaultHeight,
			width : 624,
			autoScroll : true,
			title : 'Eigenschaft',
			items : [this.grids.lvlURLText, this.grids.lvlURLButton]
		});
		
		this.grids.lvlURL.parent = this;
		this.grids.lvlURLText.parent = this;
		this.grids.lvlURLButton.parent = this;
		this.macPanel.add(this.grids.lvlURL);		
	},
	constructGridLvlGroup : function(zoneID) {
		var oGroupControlStore = Ext.create('Ext.data.Store', {
			fields : [ 'id', 'group', 'name', 'icon',
					'reachable' ],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});

		var oGroupStore = this.getGroupStore(zoneID);
		oGroupStore.each(function(record) {
			var oNewRecord = record.copy()
			if (oNewRecord.get('reachable')) {
				if (oNewRecord.get('group') != 0)
					oGroupControlStore.add(oNewRecord);
				if (oNewRecord.get('group') == 1)
					oGroupControlStore.add({
						id:-1,
						group:null,
						name:oNewRecord.get('name') + ' blinken',
						icon:'images/sceneIcons/scene_blink.png',
						reachable:oNewRecord.get('reachable')});
			}
		});
		oGroupControlStore.add({
			group : -1,
			name : '-',
			icon : null,
			reachable : true
		});
		var oSceneGroup0Store = this.getSceneStore(zoneID, 0);
		oSceneGroup0Store.each(function(record) {
			var oNewRecord = record.copy()
			if (oNewRecord.get('reachable'))
				oGroupControlStore.add(oNewRecord);
		});

		this.grids.lvlGroup = Ext.create('Ext.grid.Panel', {
			height : this.iDefaultHeight,
			width : this.iDefaultWidth,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			store : oGroupControlStore,
			columns : [ {
				sortable : false,
				hideable : false,
				text : 'Aktivit&auml;t',
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});
		this.grids.lvlGroup.on('itemdblclick',function(grid, record) {
			if (record.get('id') == null)
				return;
			if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
				var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');			
				if (record.get('id')<0) {
					var oObject = {
							type : 'zone-blink',
							params : {
								zone : zoneID,
								group : Math.abs(record.get('id'))
							}
						};
					this.parent.setSelectedSubItem(oObject);
				} else {
					var oObject = {
						type : 'zone-scene',
						params : {
							zone : zoneID,
							group : 0,
							scene : record.get('id'),
							force : false
						}
					};
					this.parent.setSelectedSubItem(oObject);
				}
			}
		});

		this.grids.lvlGroup.on('itemclick', function(grid,record) {
			this.parent.macPanel.remove(this.parent.grids.lvlScene);
			if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
				var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
				var groupID = record.get('group');
				if ((zoneID != null) && (groupID != null)) {
					this.parent.constructGridLvlGroupScene(
							zoneID, groupID);
				}
			}
		});

		this.grids.lvlGroup.parent = this;
		this.macPanel.add(this.grids.lvlGroup);
	},
	constructMacGrids : function() {
		this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
			height : this.iDefaultHeight,
			width : this.iDefaultWidth,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			store : Ext.data.StoreManager
					.lookup('actionConfigurator_l1Store'),
			columns : [ {
				sortable : false,
				hideable : false,
				text : 'Handlung',
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});
		this.grids.lvl1.parent = this;
		this.grids.lvl1.on('itemdblclick',function(grid, record) {
							if (record.get('id') == -1)
								return;
							if (record.get('next') == false) {
								var oObject = {
									type : 'zone-scene',
									params : {
										zone : 0,
										group : 0,
										scene : null,
										force : false
									}
								};

								if (record.get('id') == 4) // panic
								{
									oObject.params.scene = 65;
								}
								if (record.get('id') == 5) // klingel
								{
									oObject.params.scene = 73;
								}

								if (record.get('id') == 6) // gehen
								{
									oObject.params.scene = 72;
								}
								if (record.get('id') == 7) // kommen
								{
									oObject.params.scene = 71;
								}
								if (record.get('id') == 8) // schlafen
								{
									oObject.params.scene = 69;
								}
								if (record.get('id') == 9) // aufwachen
								{
									oObject.params.scene = 70;
								}
								if (oObject.params.scene != null) {
									this.parent.setSelectedSubItem(oObject);
								}
							}
						});
		this.grids.lvl1.on('itemclick',function(grid, record) {
							this.parent.macPanel
									.remove(this.parent.grids.lvlDeviceScene);
							this.parent.macPanel
									.remove(this.parent.grids.lvlDeviceAction);
							this.parent.macPanel
									.remove(this.parent.grids.lvlRoom);
							this.parent.macPanel
									.remove(this.parent.grids.lvlHighLevelEvent);
							this.parent.macPanel
									.remove(this.parent.grids.lvlURL);
							this.parent.macPanel
									.remove(this.parent.grids.lvlGroup);
							this.parent.macPanel
									.remove(this.parent.grids.lvlScene);
							this.parent.macPanel
									.remove(this.parent.grids.lvlDevice);
							if (record.get('id') == 0) {
								this.parent
										.constructGridLvlRoom();
							} else if (record.get('id') == 1) {
								this.parent
										.constructGridLvlRoom();
							} else if (record.get('id') == 2) {
								this.parent
										.constructGridLvlHigh();
							} else if (record.get('id') == 3) {
								this.parent
										.constructGridLvlURL();
							}
							this.parent.macPanel.doLayout();
						});

	},
	setSelectedSubItem:function(oObject) {
		if (this.mainGrid.getSelectionModel().getSelection().length == 0) {
			this.gridStore.add({
				pos : 0,
				action : oObject
			});
		} else {
			this.mainGrid.getSelectionModel().getSelection()[0].set('action',oObject);
		}		
		this.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM,true);		
	},
	setMacGrid:function(oObject){
		this.macPanel.remove(this.grids.lvlDeviceScene);
		this.macPanel.remove(this.grids.lvlDeviceAction);
		this.macPanel.remove(this.grids.lvlRoom);
		this.macPanel.remove(this.grids.lvlHighLevelEvent);
		this.macPanel.remove(this.grids.lvlURL);
		this.macPanel.remove(this.grids.lvlGroup);
		this.macPanel.remove(this.grids.lvlScene);
		this.macPanel.remove(this.grids.lvlDevice);
		switch (oObject.type)
		{
			case 'zone-scene':
				this.grids.lvl1.getSelectionModel().select(0);
				if (oObject.params.zone==0)
				{
					if (oObject.params.scene==65)
						this.grids.lvl1.getSelectionModel().select(5);
					if (oObject.params.scene==73)
						this.grids.lvl1.getSelectionModel().select(6);
					if (oObject.params.scene==72)
						this.grids.lvl1.getSelectionModel().select(7);
					if (oObject.params.scene==71)
						this.grids.lvl1.getSelectionModel().select(8);
					if (oObject.params.scene==69)
						this.grids.lvl1.getSelectionModel().select(9);
					if (oObject.params.scene==70)
						this.grids.lvl1.getSelectionModel().select(10);
				} else {
					this.constructGridLvlRoom();
					var oRecordZone=this.grids.lvlRoom.store.find('ZoneID',oObject.params.zone);
					if (oRecordZone!=null)
						this.grids.lvlRoom.getSelectionModel().select(oRecordZone);	
					
					this.constructGridLvlGroup(oObject.params.zone)
					if (oObject.params.group==0)
					{
						var oRecordGroup=this.grids.lvlGroup.store.find('id',oObject.params.scene);
						if (oRecordGroup!=null)
							this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);						
					} else {
						var oRecordGroup=this.grids.lvlGroup.store.find('group',oObject.params.group);
						if (oRecordGroup!=null)
							this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);												
						this.constructGridLvlGroupScene(oObject.params.zone,oObject.params.group,false,oObject.params.force);
						
						var oRecordScene=this.grids.lvlScene.store.find('id',oObject.params.scene);
						if (oRecordScene!=-1)
							this.grids.lvlScene.getSelectionModel().select(oRecordScene);	
						else {
							this.macPanel.remove(this.grids.lvlScene);
							this.constructGridLvlGroupScene(oObject.params.zone,oObject.params.group,true,oObject.params.force);							
							var oRecordScene=this.grids.lvlScene.store.find('id',oObject.params.scene);
							if (oRecordScene!=-1)
								this.grids.lvlScene.getSelectionModel().select(oRecordScene);								
						}
						if (oRecordScene>11) {
							var me=this;
							var fn=function() {
								me.grids.lvlScene.setScrollTop((oRecordScene)*21);
							};
							window.setTimeout(fn,10);
						}
							
					}
				}				
			break;
			case 'device-scene':				
				this.grids.lvl1.getSelectionModel().select(1);
				var zoneID=dss.staticDataModel.getDevice(oObject.params.dsid).ZoneID;
				var groupID=dss.staticDataModel.getDevice(oObject.params.dsid).GroupID;
				this.constructGridLvlRoom();				
				var oRecordZone=this.grids.lvlRoom.store.find('ZoneID',zoneID);
				if (oRecordZone!=null)
					this.grids.lvlRoom.getSelectionModel().select(oRecordZone);	
				
				this.constructGridLvlDevice(zoneID);
				var oRecordDevice=this.grids.lvlDevice.store.find('dSID',oObject.params.dsid);
				if (oRecordDevice!=null)
					this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);	
				
				this.constructGridLvlDeviceActions(oObject.params.dsid);
				if (oObject.params.scene==13){ //id:1 					
					this.grids.lvlDeviceAction.getSelectionModel().select(this.grids.lvlDeviceAction.store.find('id',1));	
				} else if (oObject.params.scene==14) { //id:2
					this.grids.lvlDeviceAction.getSelectionModel().select(this.grids.lvlDeviceAction.store.find('id',2));	
				} else if (oObject.params.scene==51) { //id:3
					this.grids.lvlDeviceAction.getSelectionModel().select(this.grids.lvlDeviceAction.store.find('id',3));	
				} else {
					this.grids.lvlDeviceAction.getSelectionModel().select(this.grids.lvlDeviceAction.store.find('id',5));	
					this.constructGridLvlDeviceScene(zoneID, groupID);					

					var oRecordScene=this.grids.lvlDeviceScene.store.find('id',oObject.params.scene,false,oObject.params.force);
					if (oRecordScene!=-1)
						this.grids.lvlDeviceScene.getSelectionModel().select(oRecordScene);	
					else {
						this.macPanel.remove(this.grids.lvlDeviceScene);
						this.constructGridLvlDeviceScene(oObject.params.zone,oObject.params.group,true,oObject.params.force);							
						var oRecordScene=this.grids.lvlDeviceScene.store.find('id',oObject.params.scene);
						if (oRecordScene!=-1)
							this.grids.lvlDeviceScene.getSelectionModel().select(oRecordScene);								
					}
					if (oRecordScene>11) {
						var me=this;
						var fn=function() {
							me.grids.lvlDeviceScene.setScrollTop((oRecordScene)*21);
						};
						window.setTimeout(fn,10);
					}
					
				}				
			break;
			case 'device-value':
				// nicht unterstuetzt aktuell
			break;
			case 'device-blink':
				this.grids.lvl1.getSelectionModel().select(1);
				var zoneID=dss.staticDataModel.getDevice(oObject.params.dsid).ZoneID;
				var groupID=dss.staticDataModel.getDevice(oObject.params.dsid).GroupID;
				this.constructGridLvlRoom();				
				var oRecordZone=this.grids.lvlRoom.store.find('ZoneID',zoneID);
				if (oRecordZone!=null)
					this.grids.lvlRoom.getSelectionModel().select(oRecordZone);	
				
				this.constructGridLvlDevice(zoneID);
				var oRecordDevice=this.grids.lvlDevice.store.find('dSID',oObject.params.dsid);
				if (oRecordDevice!=null)
					this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);	
				
				this.constructGridLvlDeviceActions(oObject.params.dsid);
				this.grids.lvlDeviceAction.getSelectionModel().select(this.grids.lvlDeviceAction.store.find('id',4));	
			break;
			case 'zone-blink':	
				this.grids.lvl1.getSelectionModel().select(0);
				this.constructGridLvlRoom();
				var oRecordZone=this.grids.lvlRoom.store.find('ZoneID',oObject.params.zone);
				if (oRecordZone!=null)
					this.grids.lvlRoom.getSelectionModel().select(oRecordZone);	
				
				this.constructGridLvlGroup(oObject.params.zone)
				var oRecordGroup=this.grids.lvlGroup.store.find('id',-1*oObject.params.group);
				if (oRecordGroup!=null)
					this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);												

			break;
			case 'custom-event':
				this.grids.lvl1.getSelectionModel().select(2);
				this.constructGridLvlHigh();
				var oRecord=this.grids.lvlHighLevelEvent.store.find('name',oObject.params.event);
				if (oRecord!=null)
					this.grids.lvlHighLevelEvent.getSelectionModel().select(oRecord);			
			break;
			case 'url':
				this.grids.lvl1.getSelectionModel().select(3);
				this.constructGridLvlURL();
				this.grids.lvlURLText.setValue(oObject.params.url);
			break;
		}
	},
	constructor : function(config) {
		this.initStores();
		this.constructMacGrids();
		this.lblSelectorAnzeige = Ext.create('Ext.form.Label',{
			width:200,
			height:22,
			padding:4,
			style:{
				textAlign:'right',
			}
		});
		
		this.oButtonNew=Ext.create('Ext.button.Button',{	
			iconCls : 'icon-add-action',
			text : 'Neue Handlung',
			id : 'action-selector-btn-new',
			handler : function() {
				this.parent.mainGrid.getSelectionModel().deselect(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
				this.parent.macPanel.expand(true);
			}
		});
		this.oButtonNew.parent=this;
		
		this.oButtonEdit=Ext.create('Ext.button.Button',{
			iconCls : 'icon-edit-action',
			text : 'Bearbeiten',
			id : 'action-selector-btn-edit',
			disabled : true,
			handler : function() {
				this.parent.macPanel.expand(true);
				this.parent.setMacGrid((this.parent.mainGrid.getSelectionModel().getSelection()[0]).get('action'));
			}
		});	
		this.oButtonEdit.parent=this;
		
		this.oButtonUp=Ext.create('Ext.button.Button',{
			iconCls : 'icon-up-action',
			id : 'action-selector-btn-up',
			disabled : true,
			handler: function() {
				var iIndex=this.parent.mainGrid.store.indexOf(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
				this.parent.mainGrid.getSelectionModel().select(iIndex-1);
				this.parent.setMacGrid((this.parent.mainGrid.getSelectionModel().getSelection()[0]).get('action'));
			}
		});	
		this.oButtonUp.parent=this;
		
		this.oButtonDown=Ext.create('Ext.button.Button',{
			iconCls : 'icon-down-action',
			id : 'action-selector-btn-down',
			disabled : true,
			handler: function() {
				var iIndex=this.parent.mainGrid.store.indexOf(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
				this.parent.mainGrid.getSelectionModel().select(iIndex+1);
				this.parent.setMacGrid((this.parent.mainGrid.getSelectionModel().getSelection()[0]).get('action'));
			}
		});	
		this.oButtonDown.parent=this;
		
		this.oButtonDelete=Ext.create('Ext.button.Button',{
			iconCls : 'icon-delete-action',
			id : 'action-selector-btn-delete',
			disabled : true,
			handler : function() {
				this.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM,true);
				this.parent.gridStore.remove(this.parent.mainGrid.getSelectionModel().getSelection()[0]);				
			}
		} );	
		this.oButtonDelete.parent=this;
		
		this.mainGrid = Ext.create('Ext.grid.Panel', {
			enableColumnHide : false,
			enableColumnMove : false,
			selType : 'rowmodel',
			border : '0',
			region : 'center',
			height : "100%",
			selModel: {
				allowDeselect:true
			},
			store : this.gridStore,
			hideHeaders : true,
			columns : [ {
				header : 'Aktion',
				dataIndex : 'action',
				sortable : false,
				hideable : false,
				width : 774,
				renderer : this.defMainGridRenderer
			} ],
			tbar : [ this.oButtonNew ,this.oButtonEdit , 			
			// { xtype: 'button', text: 'Erweiterte Ansicht',
			// id: 'action-selector-btn-extended' ,
			// disabled:true},
			'->', this.lblSelectorAnzeige,this.oButtonUp, this.oButtonDown,this.oButtonDelete ]
		});
		this.mainGrid.parent=this;
		this.mainGrid.on({
					selectionchange : function(view,
							selections, options) {
						if (selections.length > 0) {
							this.parent.oButtonEdit.setDisabled(false);
							this.parent.oButtonDelete.setDisabled(false);
							var selIndex = -1;
							for ( var iIndex = 0; iIndex < view.store.getCount(); iIndex++) {
								if (view.store.getAt(iIndex) == selections[0])
									selIndex = iIndex;
							}
							this.parent.oButtonUp.setDisabled(selIndex == 0);
							this.parent.oButtonDown.setDisabled(selIndex == (view.store.getCount() - 1));
							var iIndex=this.parent.mainGrid.store.indexOf(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
							this.parent.lblSelectorAnzeige.setText('Handlung ' + (iIndex+1) + ' von ' + view.store.getCount());
						} else {
							this.parent.oButtonEdit.setDisabled(true);
							this.parent.oButtonDelete.setDisabled(true);
							this.parent.oButtonUp.setDisabled(true);
							this.parent.oButtonDown.setDisabled(true);
							this.parent.lblSelectorAnzeige.setText(''+view.store.getCount() + ' Handlungen');
						}
					}
				});

		this.macPanel = Ext.create(
			'Ext.panel.Panel',
			{
				border : '0',
				region : 'south',
				title : 'Handlung Bearbeiten anzeigen',
				collapsible : true,
				collapsed : true,
				collapseMode : 'header',
				autoScroll : true,
				height : 320,
				layout : {
					type : 'hbox'
				},
				items : [ this.grids.lvl1 ],
				listeners : {
					collapse : function(pPanel) {
						pPanel.setTitle('Handlung Bearbeiten anzeigen');
					},
					expand : function(pPanel) {
						pPanel.setTitle('Handlung Bearbeiten ausblenden');
					}
				},
				scroll : 'horizontal'
	
			});

		Ext.apply(this, {
			items : [ this.mainGrid, this.macPanel ]
		});

		this.callParent(arguments);
	},
	reset : function()
	{
		this.setValue(null);
	},
	setValue : function(values) {
		this.macPanel.remove(this.grids.lvlDeviceScene);
		this.macPanel.remove(this.grids.lvlDeviceAction);
		this.macPanel.remove(this.grids.lvlRoom);
		this.macPanel.remove(this.grids.lvlHighLevelEvent);
		this.macPanel.remove(this.grids.lvlURL);
		this.macPanel.remove(this.grids.lvlGroup);
		this.macPanel.remove(this.grids.lvlScene);
		this.macPanel.remove(this.grids.lvlDevice);
		if (values==null)
		{
			this.gridStore.removeAll();
		} else {
			this.gridStore.removeAll();
			for (var iIndex=0;iIndex<values.length;iIndex++)
			{
				var oObject={
						type:values[iIndex].type,
						params:{}
				};
				for (var sKey in values[iIndex])
				{
					if (sKey!="type")
						oObject.params[sKey]=values[iIndex][sKey];
				}
				this.gridStore.add({action:oObject});
			}
		}
	},	
	isValid : function() {
		return this.gridStore.getCount()>0;
	},
	getValue : function() {
		var oResult=[];
		this.gridStore.each(function(record) {
			var oObject={};
			var oRecord=record.get('action');
			oObject.type=oRecord.type;
			for (var oKey in oRecord.params)
			{
				oObject[oKey]=oRecord.params[oKey];
			}			
			oResult.push(oObject);
		});		
		return oResult;
	}
}); // DSS.component.ActionConfigurator

